Index: trunk/FACT++/gui/FactGui.h
===================================================================
--- trunk/FACT++/gui/FactGui.h	(revision 12266)
+++ trunk/FACT++/gui/FactGui.h	(revision 12273)
@@ -2827,5 +2827,13 @@
                 SetLedColor(fStatusFeedbackLed, kLedGray, time);
 
-            //fFeedbackWidget->setEnabled(s.index>=3);
+            fFeedbackWidget->setEnabled(s.index>=3);
+            fFeedbackStop->setEnabled(s.index>4);
+            fFeedbackTempStart->setEnabled(s.index==4);
+            fFeedbackTempOffset->setEnabled(s.index<=4);
+            fFeedbackOutputEnable->setEnabled(s.index<=6);
+            fFeedbackOutputDisable->setEnabled(s.index!=5 && s.index!=6);
+
+            fFeedbackFrameLeft->setEnabled(s.index!=5 && s.index!=7);
+            fFeedbackCanvLeft->setEnabled(s.index!=5 && s.index!=7);
         }
 
@@ -3947,5 +3955,5 @@
         hf->GetYaxis()->SetTitleOffset(0.55);
         hf->GetXaxis()->SetTitle("");
-        hf->GetYaxis()->SetRangeUser(-99*5, 99*5);
+        hf->GetYaxis()->SetRangeUser(-99*10, 99*10);
 
         fGraphFeedbackCmd.Draw("LP");
Index: trunk/FACT++/gui/MainWindow.cc
===================================================================
--- trunk/FACT++/gui/MainWindow.cc	(revision 12266)
+++ trunk/FACT++/gui/MainWindow.cc	(revision 12273)
@@ -589,4 +589,25 @@
 }
 
+void MainWindow::on_fFeedbackTempStart_clicked()
+{
+    Dim::SendCommand("FEEDBACK/START_TEMP_CONTROL",
+                     (float)fFeedbackTempOffset->value());
+}
+
+void MainWindow::on_fFeedbackOutputEnable_clicked()
+{
+    Dim::SendCommand("FEEDBACK/ENABLE_OUTPUT", uint8_t(1));
+}
+
+void MainWindow::on_fFeedbackOutputDisable_clicked()
+{
+    Dim::SendCommand("FEEDBACK/ENABLE_OUTPUT", uint8_t(0));
+}
+
+void MainWindow::on_fFeedbackStop_clicked()
+{
+    Dim::SendCommand("FEEDBACK/STOP");
+}
+
 void MainWindow::on_fBiasVoltDac_valueChanged(int val)
 {
Index: trunk/FACT++/gui/MainWindow.h
===================================================================
--- trunk/FACT++/gui/MainWindow.h	(revision 12266)
+++ trunk/FACT++/gui/MainWindow.h	(revision 12273)
@@ -159,4 +159,8 @@
     void on_fFeedbackCmdMin_valueChanged(int);
     void on_fFeedbackCmdMax_valueChanged(int);
+    void on_fFeedbackTempStart_clicked();
+    void on_fFeedbackOutputEnable_clicked();
+    void on_fFeedbackOutputDisable_clicked();
+    void on_fFeedbackStop_clicked();
 
     // Tab: Bias
Index: trunk/FACT++/gui/design.ui
===================================================================
--- trunk/FACT++/gui/design.ui	(revision 12266)
+++ trunk/FACT++/gui/design.ui	(revision 12273)
@@ -12,5 +12,5 @@
     <y>0</y>
     <width>1425</width>
-    <height>927</height>
+    <height>925</height>
    </rect>
   </property>
@@ -53,5 +53,5 @@
       </property>
       <property name="currentIndex">
-       <number>10</number>
+       <number>5</number>
       </property>
       <property name="documentMode">
@@ -4474,5 +4474,5 @@
            <layout class="QGridLayout" name="gridLayout_85" rowstretch="3,2">
             <item row="0" column="0">
-             <widget class="QFrame" name="frame_7">
+             <widget class="QFrame" name="fFeedbackFrameLeft">
               <property name="sizePolicy">
                <sizepolicy hsizetype="Expanding" vsizetype="Expanding">
@@ -4682,5 +4682,5 @@
                    </property>
                    <property name="value">
-                    <number>-500</number>
+                    <number>-1000</number>
                    </property>
                   </widget>
@@ -4730,5 +4730,5 @@
                    </property>
                    <property name="value">
-                    <number>500</number>
+                    <number>1000</number>
                    </property>
                   </widget>
@@ -4740,5 +4740,5 @@
             </item>
             <item row="1" column="0">
-             <widget class="QFrame" name="frame_9">
+             <widget class="QFrame" name="fFeedbackCanvLeft">
               <property name="frameShape">
                <enum>QFrame::StyledPanel</enum>
@@ -4768,4 +4768,134 @@
               </layout>
              </widget>
+            </item>
+            <item row="0" column="2" rowspan="2">
+             <layout class="QVBoxLayout" name="verticalLayout_19">
+              <property name="rightMargin">
+               <number>0</number>
+              </property>
+              <item>
+               <widget class="QGroupBox" name="groupBox_23">
+                <property name="title">
+                 <string>Temp feedback</string>
+                </property>
+                <layout class="QGridLayout" name="gridLayout_99">
+                 <item row="0" column="0">
+                  <widget class="QLabel" name="label_247">
+                   <property name="text">
+                    <string>Voltage offset</string>
+                   </property>
+                   <property name="alignment">
+                    <set>Qt::AlignBottom|Qt::AlignLeading|Qt::AlignLeft</set>
+                   </property>
+                  </widget>
+                 </item>
+                 <item row="3" column="0">
+                  <widget class="QDoubleSpinBox" name="fFeedbackTempOffset">
+                   <property name="alignment">
+                    <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
+                   </property>
+                   <property name="suffix">
+                    <string> V</string>
+                   </property>
+                   <property name="minimum">
+                    <double>-2.500000000000000</double>
+                   </property>
+                   <property name="maximum">
+                    <double>2.500000000000000</double>
+                   </property>
+                   <property name="singleStep">
+                    <double>0.100000000000000</double>
+                   </property>
+                  </widget>
+                 </item>
+                 <item row="4" column="0">
+                  <widget class="QPushButton" name="fFeedbackTempStart">
+                   <property name="text">
+                    <string>Start</string>
+                   </property>
+                  </widget>
+                 </item>
+                </layout>
+               </widget>
+              </item>
+              <item>
+               <widget class="QGroupBox" name="groupBox_24">
+                <property name="title">
+                 <string>Gain feedback</string>
+                </property>
+                <layout class="QGridLayout" name="gridLayout_100">
+                 <item row="0" column="0">
+                  <widget class="QPushButton" name="pushButton_5">
+                   <property name="enabled">
+                    <bool>false</bool>
+                   </property>
+                   <property name="text">
+                    <string>Start</string>
+                   </property>
+                  </widget>
+                 </item>
+                </layout>
+               </widget>
+              </item>
+              <item>
+               <widget class="QGroupBox" name="groupBox_25">
+                <property name="title">
+                 <string>Global</string>
+                </property>
+                <layout class="QGridLayout" name="gridLayout_101">
+                 <item row="3" column="0">
+                  <widget class="QPushButton" name="fFeedbackStop">
+                   <property name="text">
+                    <string>Stop</string>
+                   </property>
+                  </widget>
+                 </item>
+                 <item row="1" column="0">
+                  <widget class="QPushButton" name="fFeedbackOutputDisable">
+                   <property name="text">
+                    <string>Disable output</string>
+                   </property>
+                  </widget>
+                 </item>
+                 <item row="0" column="0">
+                  <widget class="QPushButton" name="fFeedbackOutputEnable">
+                   <property name="text">
+                    <string>Enable output</string>
+                   </property>
+                  </widget>
+                 </item>
+                 <item row="2" column="0">
+                  <spacer name="verticalSpacer_78">
+                   <property name="orientation">
+                    <enum>Qt::Vertical</enum>
+                   </property>
+                   <property name="sizeType">
+                    <enum>QSizePolicy::Fixed</enum>
+                   </property>
+                   <property name="sizeHint" stdset="0">
+                    <size>
+                     <width>20</width>
+                     <height>10</height>
+                    </size>
+                   </property>
+                  </spacer>
+                 </item>
+                </layout>
+               </widget>
+              </item>
+              <item>
+               <spacer name="verticalSpacer_77">
+                <property name="orientation">
+                 <enum>Qt::Vertical</enum>
+                </property>
+                <property name="sizeHint" stdset="0">
+                 <size>
+                  <width>20</width>
+                  <height>40</height>
+                 </size>
+                </property>
+               </spacer>
+              </item>
+             </layout>
             </item>
            </layout>