Index: /trunk/FACT++/gui/design.ui
===================================================================
--- /trunk/FACT++/gui/design.ui	(revision 12287)
+++ /trunk/FACT++/gui/design.ui	(revision 12288)
@@ -53,5 +53,5 @@
       </property>
       <property name="currentIndex">
-       <number>5</number>
+       <number>3</number>
       </property>
       <property name="documentMode">
@@ -2948,5 +2948,5 @@
                     <size>
                      <width>20</width>
-                     <height>20</height>
+                     <height>15</height>
                     </size>
                    </property>
@@ -3095,5 +3095,5 @@
                     <size>
                      <width>20</width>
-                     <height>40</height>
+                     <height>20</height>
                     </size>
                    </property>
@@ -3103,5 +3103,5 @@
                   <widget class="QLabel" name="label_24">
                    <property name="text">
-                    <string>Threshold</string>
+                    <string>Patch threshold</string>
                    </property>
                   </widget>
@@ -3155,5 +3155,31 @@
                  </item>
                  <item>
-                  <spacer name="verticalSpacer">
+                  <widget class="QLabel" name="label_69">
+                   <property name="text">
+                    <string>Patch Rate</string>
+                   </property>
+                  </widget>
+                 </item>
+                 <item>
+                  <widget class="QDoubleSpinBox" name="fPatchRate">
+                   <property name="alignment">
+                    <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
+                   </property>
+                   <property name="readOnly">
+                    <bool>true</bool>
+                   </property>
+                   <property name="buttonSymbols">
+                    <enum>QAbstractSpinBox::NoButtons</enum>
+                   </property>
+                   <property name="suffix">
+                    <string> Hz</string>
+                   </property>
+                   <property name="maximum">
+                    <double>999999999.000000000000000</double>
+                   </property>
+                  </widget>
+                 </item>
+                 <item>
+                  <spacer name="verticalSpacer_79">
                    <property name="orientation">
                     <enum>Qt::Vertical</enum>
@@ -3165,5 +3191,5 @@
                     <size>
                      <width>20</width>
-                     <height>5</height>
+                     <height>20</height>
                     </size>
                    </property>
@@ -3171,12 +3197,72 @@
                  </item>
                  <item>
-                  <widget class="QLabel" name="label_69">
+                  <widget class="QLabel" name="label_248">
                    <property name="text">
-                    <string>Rate</string>
+                    <string>N-out-of-4 threshold</string>
                    </property>
                   </widget>
                  </item>
                  <item>
-                  <widget class="QDoubleSpinBox" name="fPatchRate">
+                  <widget class="QSpinBox" name="fNoutof4Val">
+                   <property name="alignment">
+                    <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
+                   </property>
+                   <property name="specialValueText">
+                    <string>inconsistent</string>
+                   </property>
+                   <property name="minimum">
+                    <number>-1</number>
+                   </property>
+                   <property name="maximum">
+                    <number>4095</number>
+                   </property>
+                  </widget>
+                 </item>
+                 <item>
+                  <widget class="QDoubleSpinBox" name="fNoutof4Volt">
+                   <property name="sizePolicy">
+                    <sizepolicy hsizetype="Minimum" vsizetype="Fixed">
+                     <horstretch>0</horstretch>
+                     <verstretch>0</verstretch>
+                    </sizepolicy>
+                   </property>
+                   <property name="minimumSize">
+                    <size>
+                     <width>100</width>
+                     <height>0</height>
+                    </size>
+                   </property>
+                   <property name="alignment">
+                    <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
+                   </property>
+                   <property name="readOnly">
+                    <bool>true</bool>
+                   </property>
+                   <property name="buttonSymbols">
+                    <enum>QAbstractSpinBox::NoButtons</enum>
+                   </property>
+                   <property name="suffix">
+                    <string> mV</string>
+                   </property>
+                   <property name="decimals">
+                    <number>1</number>
+                   </property>
+                   <property name="maximum">
+                    <double>2500.000000000000000</double>
+                   </property>
+                   <property name="value">
+                    <double>0.000000000000000</double>
+                   </property>
+                  </widget>
+                 </item>
+                 <item>
+                  <widget class="QLabel" name="label_249">
+                   <property name="text">
+                    <string>Board rate</string>
+                   </property>
+                  </widget>
+                 </item>
+                 <item>
+                  <widget class="QDoubleSpinBox" name="fBoardRate">
                    <property name="alignment">
                     <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>