Index: trunk/FACT++/Makefile.am
===================================================================
--- trunk/FACT++/Makefile.am	(revision 12353)
+++ trunk/FACT++/Makefile.am	(revision 12354)
@@ -38,5 +38,5 @@
 	chatclient chatserv \
 	biasctrl \
-	mcp feedback ratescan \
+	mcp feedback ratescan ratecontrol \
 	fitsdump
 
@@ -288,4 +288,9 @@
     	libConfiguration.la
 
+ratecontrol_SOURCES = src/ratecontrol.cc src/LocalControl.h src/PixelMap.cc
+ratecontrol_LDADD   = libDim.la libDim++.la  libDimExtension.la \
+	libTime.la libTools.la libStateMachine.la \
+    	libConfiguration.la
+
 
 argv_SOURCES = src/argv.cc
Index: trunk/FACT++/Makefile.in
===================================================================
--- trunk/FACT++/Makefile.in	(revision 12353)
+++ trunk/FACT++/Makefile.in	(revision 12354)
@@ -49,6 +49,6 @@
 	chatclient$(EXEEXT) chatserv$(EXEEXT) biasctrl$(EXEEXT) \
 	mcp$(EXEEXT) feedback$(EXEEXT) ratescan$(EXEEXT) \
-	fitsdump$(EXEEXT) $(am__EXEEXT_1) $(am__EXEEXT_2) \
-	$(am__EXEEXT_3) $(am__EXEEXT_4)
+	ratecontrol$(EXEEXT) fitsdump$(EXEEXT) $(am__EXEEXT_1) \
+	$(am__EXEEXT_2) $(am__EXEEXT_3) $(am__EXEEXT_4)
 @HAS_GUI_TRUE@am__append_1 = fact
 @HAS_VIEWER_TRUE@am__append_2 = viewer
@@ -315,4 +315,9 @@
 mcp_DEPENDENCIES = libDim.la libDim++.la libDimExtension.la libTime.la \
 	libTools.la libStateMachine.la libConfiguration.la
+am_ratecontrol_OBJECTS = src/ratecontrol.$(OBJEXT) \
+	src/PixelMap.$(OBJEXT)
+ratecontrol_OBJECTS = $(am_ratecontrol_OBJECTS)
+ratecontrol_DEPENDENCIES = libDim.la libDim++.la libDimExtension.la \
+	libTime.la libTools.la libStateMachine.la libConfiguration.la
 am_ratescan_OBJECTS = src/ratescan.$(OBJEXT) src/PixelMap.$(OBJEXT)
 ratescan_OBJECTS = $(am_ratescan_OBJECTS)
@@ -415,6 +420,6 @@
 	$(fscctrl_SOURCES) $(ftm_SOURCES) $(ftmctrl_SOURCES) \
 	$(log_SOURCES) $(logtime_SOURCES) $(mcp_SOURCES) \
-	$(ratescan_SOURCES) $(readfits_SOURCES) sched.c \
-	$(scheduler_SOURCES) $(test_SOURCES) $(time_SOURCES) \
+	$(ratecontrol_SOURCES) $(ratescan_SOURCES) $(readfits_SOURCES) \
+	sched.c $(scheduler_SOURCES) $(test_SOURCES) $(time_SOURCES) \
 	$(triggerschedule_SOURCES) $(viewer_SOURCES)
 DIST_SOURCES = $(libConfiguration_la_SOURCES) $(libDim___la_SOURCES) \
@@ -431,7 +436,8 @@
 	$(fsc_SOURCES) $(fscctrl_SOURCES) $(ftm_SOURCES) \
 	$(ftmctrl_SOURCES) $(log_SOURCES) $(logtime_SOURCES) \
-	$(mcp_SOURCES) $(ratescan_SOURCES) $(readfits_SOURCES) sched.c \
-	$(scheduler_SOURCES) $(test_SOURCES) $(time_SOURCES) \
-	$(triggerschedule_SOURCES) $(am__viewer_SOURCES_DIST)
+	$(mcp_SOURCES) $(ratecontrol_SOURCES) $(ratescan_SOURCES) \
+	$(readfits_SOURCES) sched.c $(scheduler_SOURCES) \
+	$(test_SOURCES) $(time_SOURCES) $(triggerschedule_SOURCES) \
+	$(am__viewer_SOURCES_DIST)
 man1dir = $(mandir)/man1
 NROFF = nroff
@@ -865,4 +871,9 @@
     	libConfiguration.la
 
+ratecontrol_SOURCES = src/ratecontrol.cc src/LocalControl.h src/PixelMap.cc
+ratecontrol_LDADD = libDim.la libDim++.la  libDimExtension.la \
+	libTime.la libTools.la libStateMachine.la \
+    	libConfiguration.la
+
 argv_SOURCES = src/argv.cc
 argv_LDADD = libConfiguration.la
@@ -1364,4 +1375,9 @@
 	@rm -f mcp$(EXEEXT)
 	$(AM_V_CXXLD)$(CXXLINK) $(mcp_OBJECTS) $(mcp_LDADD) $(LIBS)
+src/ratecontrol.$(OBJEXT): src/$(am__dirstamp) \
+	src/$(DEPDIR)/$(am__dirstamp)
+ratecontrol$(EXEEXT): $(ratecontrol_OBJECTS) $(ratecontrol_DEPENDENCIES) 
+	@rm -f ratecontrol$(EXEEXT)
+	$(AM_V_CXXLD)$(CXXLINK) $(ratecontrol_OBJECTS) $(ratecontrol_LDADD) $(LIBS)
 src/ratescan.$(OBJEXT): src/$(am__dirstamp) \
 	src/$(DEPDIR)/$(am__dirstamp)
@@ -1557,4 +1573,5 @@
 	-rm -f src/logtime.$(OBJEXT)
 	-rm -f src/mcp.$(OBJEXT)
+	-rm -f src/ratecontrol.$(OBJEXT)
 	-rm -f src/ratescan.$(OBJEXT)
 	-rm -f src/readfits.$(OBJEXT)
@@ -1669,4 +1686,5 @@
 @AMDEP_TRUE@@am__include@ @am__quote@src/$(DEPDIR)/logtime.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@src/$(DEPDIR)/mcp.Po@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@src/$(DEPDIR)/ratecontrol.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@src/$(DEPDIR)/ratescan.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@src/$(DEPDIR)/readfits.Po@am__quote@